
#include <limits.h>
#include <i86.h>
#include <sys/seginfo.h>

/* a giga-byte drive */

#define	MAX_SEL		64
#define	MAX_WATCH	((long)INT_MAX * 64L)	

int			maxsel;
unsigned	watchsel[64];
unsigned	long	maxblk;

init_watch(unsigned long nblk)
{
unsigned	xblocks;

	if (nblk > MAX_WATCH) {
		nblk = MAX_WATCH;
	}
	maxblk = nblk;
	while (nblk) {
		if (nblk >= INT_MAX) {
			xblocks = INT_MAX;	
		} else {
			xblocks = nblk;
		}
		nblk -= xblocks;
		if ((watchsel[maxsel]=qnx_segment_alloc(xblocks*sizeof(int))) == -1) {
			return -1;
		}
		maxsel++;
	}
	return maxsel;
}

static unsigned short crc16a[] = {
	  0000000, 0140301, 0140601, 0000500,
	  0141401, 0001700, 0001200, 0141101,
	  0143001, 0003300, 0003600, 0143501,
	  0002400, 0142701, 0142201, 0002100,
};

static unsigned short crc16b[] = {
	  0000000, 0146001, 0154001, 0012000,
	  0170001, 0036000, 0024000, 0162001,
	  0120001, 0066000, 0074000, 0132001,
	  0050000, 0116001, 0104001, 0043000,
};

calc_crc(const unsigned char __far *bufp, int len)
{
unsigned short crc = 0;
unsigned short temp;

	while (len--) {
		temp = crc ^ *bufp++;
		crc >>= 8;
		crc ^= crc16a[temp & 0017];
		crc ^= crc16b[(temp & 0360)>>4];
	}
	return crc ? crc : 1;
}

check_block(unsigned long blockno,const unsigned char __far *bufp,int sflag)
{
int	far *p;
unsigned crc_cal;

	if (blockno > maxblk)
		return 0;			/* can't check it */
		
	crc_cal = calc_crc(bufp,512);
	p = MK_FP(watchsel[blockno >> 15],(blockno & 0x7fff) << 1);

	if (*p == 0 || sflag) {
		*p = crc_cal;
		return 0;
	}
	return (*p == crc_cal) ? 0 : -1;
}
