#include <stdio.h>
#include <stdlib.h>
#if  0
#include <sys/_devdrvr.h>
#endif
#include <sys/io_msg.h>
#include <sys/dev_msg.h>
#include <sys/proc_msg.h>
#include <sys/kernel.h>
#include <errno.h>

#ifdef __WATCOMC__
#include <_devdrvr.h>
#include <pragma.h>
#include <string.h>
#endif


/*
 * This routine will "find" the Device Administrator if present
 */

pid_t dev_admin = -1;

short 
dev_drvr_register(name,prefix,nttys,kick_addr,stty_addr,ctrl_addr,drv_ctrl)
const char *name;
const char *prefix;
short nttys; 
short (__far *kick_addr)(struct output_buffer __far *);
short (__far *stty_addr)(void __far *);
short (__far *ctrl_addr)(void __far *);
struct driver_ctrl *drv_ctrl;
	{                                                             
	union _driver_msg {
		struct _driver_register			driver_register;
		struct _driver_register_reply	driver_register_reply;
		} msg;
	unsigned myds, mycs;
	struct _prefix_lookup {
		struct _io_open open;
		char name[4];
		} pmsg;

	if(dev_admin == -1) {
#ifdef __WATCOMC__
		memset(&pmsg, 0, sizeof(pmsg));
#else
		zero(&pmsg, sizeof(pmsg));
#endif
		pmsg.open.type = _PROC_OPEN;
		strcpy(&pmsg.open.path[0], "/dev");
		Send(PROC_PID, &pmsg, &pmsg, sizeof(pmsg), sizeof(pmsg));
		if(pmsg.open.type == EOK)
			dev_admin = pmsg.open.pid;
		/*
		dev_admin = qnx_name_locate("_dev");
		 */
		}
	if(dev_admin == -1)
		return(-1);

	myds = my_ds();
	mycs = my_cs();
#if 0
	qnx_segment_arm(dev_admin, -1 /*, PUT */);
#else
	qnx_segment_arm(dev_admin, -1, 0);
#endif
	msg.driver_register.type = _DEV_DRIVER_REGISTER;
	strncpy(msg.driver_register.name, name, 8);
	strncpy(msg.driver_register.prefix, prefix, 8);
	msg.driver_register.nttys = nttys;
	msg.driver_register.ds = myds;
	msg.driver_register.cs = mycs;
	msg.driver_register.kick_addr = (unsigned)kick_addr;
	msg.driver_register.stty_addr = (unsigned)stty_addr;
	msg.driver_register.ctrl_addr = (unsigned)ctrl_addr;

	Send(dev_admin, &msg, &msg, sizeof(msg.driver_register),
			sizeof(msg.driver_register_reply));
	if(msg.driver_register_reply.status != 0)
		return(-1);

	memcpy(drv_ctrl, &msg.driver_register_reply.ctrl,
			sizeof(msg.driver_register_reply.ctrl));

	return(msg.driver_register_reply.handle);
	}


short unsigned
dev_drvr_mount(handle, tty, nttys, ctrl)
int handle, tty, nttys;
struct device_ctrl *ctrl;
	{
	union _driver_msg {
		struct _driver_mount		driver_mount;
		struct _driver_mount_reply	driver_mount_reply;
		} msg;
	int i, index, n;
	long size, nsize;
	char *offset;
	unsigned seg, new;
	register struct device_ctrl *ctl;

	if(dev_admin == -1)
		return(-1);

	index = 0;
	/*
	 * Allocate resources in chunks of 64K
	 */
	while(index < nttys) {
		size = 0;
		for( n = index; n < nttys; ++n) {
			ctl = ctrl + n;
			nsize = (long) ctl->isize;		
			nsize += (long) ctl->osize;		
			nsize += (long) ctl->csize;		
			if(nsize >= 0x10000L)
				return(-3);
			if((size + nsize) >= 0x10000L)
				break;
			size += nsize;
			++ctl;
			}
	
		seg = qnx_segment_alloc(size);
		if(seg == 0  ||  seg == -1)
			return(-2);
#if 0
		qnx_segment_arm(dev_admin, -1 /* , GET|PUT */);
#else
		qnx_segment_arm(dev_admin, -1, 0);
#endif	
		offset = 0;
		new = 1;
	
		for(i = index; i < n; ++i) {
			ctl = ctrl + i;
			msg.driver_mount.type = _DEV_DRIVER_MOUNT;
			msg.driver_mount.handle = handle;
			msg.driver_mount.tty = tty++;
			msg.driver_mount.new = new;
			msg.driver_mount.offset = offset;
			msg.driver_mount.seg = seg;
			msg.driver_mount.isize = ctl->isize;
			msg.driver_mount.osize = ctl->osize;
			msg.driver_mount.csize = ctl->csize;
	
			Send(dev_admin, &msg, &msg, sizeof(msg.driver_mount), sizeof(msg.driver_mount_reply));
			if(msg.driver_mount_reply.status != 0)
				return(-4);
	
			/*
			 * Successful allocation of a new device.
			 * The structure 'driver_ctrl' now contains information
			 * about this new device
			 */
	
			memcpy(ctl, &msg.driver_mount_reply.ctrl,
				sizeof(msg.driver_mount_reply.ctrl));
	
	 		offset += (ctl->isize + ctl->osize + ctl->csize);
			if(msg.driver_mount_reply.seg != seg) {
				qnx_segment_free(seg);
				seg = msg.driver_mount_reply.seg;
				}
			new = 0;
			}
		index = n;
		}

	return(0);
	}


int dev_drvr_arm(tty)
int tty;
	{
	union _driver_msg {
		struct _driver_arm			driver_arm;
		struct _driver_arm_reply	driver_arm_reply;
		} msg;

	if(dev_admin == -1)
		return(-1);

	msg.driver_arm.type = _DEV_DRIVER_ARM;
	msg.driver_arm.tty = tty;

	Send(dev_admin, &msg, &msg, sizeof(msg.driver_arm), sizeof(msg.driver_arm_reply));
	if(msg.driver_arm_reply.status != 0)
		return(-1);

	return(0);
	}




