/*
	module to aid debugging -- pumps data out to a 'screen buffer',
	of the user's design!
*/

#include	<stdio.h>

#ifndef	DEBUGGING
#define	DEBUGGING
#endif
#include	<diskio.h>

#define	LOCAL static
#define	SCR_WIDTH	80	

static	volatile	int	line =0, col = 0;
LOCAL	int	nlines = 25;
LOCAL	int	ncols  = 80;
LOCAL	int	nattr = 0x7000;
LOCAL	int	__far	*scr = 0;

LOCAL	clear_line(void)
{
int	__far	*p = scr + line * SCR_WIDTH;
	while (col < ncols) {
		p[col++] = ' ' | nattr;
	}
	if (++line >= nlines) {
		line = 0;
	}
	clear_row(line);
	col = 0;
	return 0;
}

LOCAL	clear_row(int line)
{
int	i;
int __far	*p = scr + line * SCR_WIDTH;
	while (col < ncols) {
		p[col++] = nattr | ' ';
	}
	return 0;
}

int set_display(void __far *screen, int lines, int cols)
{
	scr = screen;
	nlines = lines;
	ncols = cols;
	line = 0;
	col = 0;
	return 0;
}

int set_attr(int attr)
{
	nattr = attr << 16;
	return 0;
}

int disp_char(int c)
{
	if (scr == NULL)
		return 0;
	if (c == '\n') {
		clear_line();
		return 0;
	}
	scr[line*SCR_WIDTH + col] = c | nattr;
	if (++col >= ncols) {
		if (++line >= nlines) {
			line = 0;
		}
		clear_row(line);
		col = 0;
	}
	return 0;
}


int disp_str(char *s)
{
	while (*s)	disp_char(*s++);
	return 0;
}



int disp_hex(int value)
{
int i;
static	char hexbuf[6];

	for(i = 3 ; i >= 0 ; --i, value >>= 4)
		hexbuf[i] = "0123456789ABCDEF"[value & 0xf];

	hexbuf[4] = ' ';
	hexbuf[5] = '\0';
	return disp_str(hexbuf);

}



int disp_lhex(long value)
{
int i;
static	char hexbuf[10];

	for(i = 7 ; i >= 0 ; --i, value >>= 4)
		hexbuf[i] = "0123456789ABCDEF"[value & 0xf];

	hexbuf[8] = ' ';
	hexbuf[9] = '\0';
	return disp_str(hexbuf);

}


