
#include <string.h>
#include <errno.h>

#include <sys/fsys_msg.h>
#include <sys/_dskdrvr.h>
#include <sys/name.h>
#include <sys/kernel.h>
#include <sys/seginfo.h>
#include <sys/sys_msg.h>
#include <diskio.h>


int fsys_mount_driver(pid_t	pid,			//	Fsys Pid 
					short	ndevs,			// Maximum number of devices
					struct _disk *devtab,	// device parameter table
					int	(**jmptab)(),		// driver entry points
					short	maxio,			// maximum io size
					short	maxpar,			// maximum parallel requests
					void	*sptr,			// pointer to stack
					struct	_sysmsg_version_reply *vers) // version stamp.	
{
union {
   struct _fsys_driver     s;
   struct _fsys_gen_reply  r;
}   msg;

    msg.s.type             = _FSYS_MOUNT_DRIVER;
    msg.s.num_devs         = ndevs;
    msg.s.jmp_tbl_off      = (unsigned)jmptab;
    msg.s.dev_tbl_off      = (unsigned)devtab;
    msg.s.ds               = my_ds();
    msg.s.cs               = my_cs();
    msg.s.sp               = (unsigned)sptr;
    msg.s.max_seq_blocks   = maxio;
    msg.s.max_parallel_ops = maxpar;
    msg.s.version_off	   = (unsigned)vers;
    qnx_segment_arm(pid, -1, 0);
    if (Send(pid, &msg.s, &msg.r, sizeof msg.s, sizeof msg.r) == -1)
	return -1;
    if(msg.r.status != EOK) {
        errno = msg.r.status;
        return(-1);
    }
    return(0);
}
