
#include	<stdio.h>
#include	<stdlib.h>
#include	<errno.h>
#include	"diskio.h"


/*
 *  Now that we have the physical block from the start of the disk
 *  (blk 0) we can break it into a track,head and sector. Not all
 *  controllers may need to know this (IE: SCSI sends block #'s to
 *  the controller).
 */

void
map_thn( BDATA *bp, DISK *dp ) 
{
const unsigned			sect_cyl = dp->d_sctr_cyl,
						sect_trk = dp->d_sctr_trk;
ldiv_t	result;

	if (sect_cyl == 0 || sect_trk == 0)
		return ;

	/* Use the more efficient 32bit/16bit divide instructions	*/

	result     = ldiv(bp->block, sect_cyl);
	bp->track  = result.quot;
	result     = ldiv(result.rem,sect_trk);
	bp->head   = result.quot;
	bp->sector = result.rem + dp->d_sctr_base;
}

long
unmap_thn(BDATA *bp, DISK *dp) 
{
	return  bp->sector - dp->d_sctr_base + 
			bp->head   * dp->d_sctr_trk  +
			bp->track  * (long) dp->d_sctr_cyl;
}

