

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <errno.h>
#include <ctype.h>
#include <process.h>
#include <unistd.h>

#include <sys/fsys_msg.h>
#include <sys/_dskdrvr.h>
#include <sys/name.h>
#include <sys/kernel.h>
#include <sys/proxy.h>
#include <sys/seginfo.h>

#include "diskio.h"


long test_disk(int drive, long cur_blk, long max_blk);

/* note: this is a littly kludgy -- we redefine fortran calling convention,
	and hit this guy.....
*/

#pragma aux (drvr_io) fortran;
static int (fortran __far *drvrio)(unsigned,unsigned,unsigned,void __far *),
	(__far *drvinit)(),
	(__far *drvopen)(),
	(__far *drvexit)();

static struct	_disk __far *device_tab;

static	pid_t		ClientPid,
			ProxyPid;

static	int	MaxIO;
static	BLOCK	*cache_list;
static	char	__far *data_area;


long	get_long(char *prompt);

int fsys_mount_driver(
	char *driver,
	unsigned num_devs,
	struct _disk *dev_tbl,
	int (**jmp_tbl)(),
	unsigned	max_seq_blks,
	unsigned	max_par_io,
	void		*sp)
{
int	i;
pid_t	pid;
	drvinit = MK_FP(my_cs(), jmp_tbl[0]);
	drvexit = MK_FP(my_cs(), jmp_tbl[1]);
	drvopen = MK_FP(my_cs(), jmp_tbl[2]);
	drvrio  = MK_FP(my_cs(), jmp_tbl[4]);
	device_tab = MK_FP(my_ds(),dev_tbl);
	MaxIO = max_seq_blks;
	if ((data_area = _fmalloc(512*MaxIO)) == (char __far *)NULL) {
		perror("fmalloc\n");
		exit(EXIT_FAILURE);
	}
	if ((ClientPid = fork()) == 0) {
		ClientPid = getppid();		/*	find dad */
						/*	tell him I love him  */
		while (1) {
			if (Send(ClientPid,data_area,data_area,16,512*MaxIO) == -1) {
				exit(EXIT_FAILURE);
			}
		}
	}
	if ((cache_list = calloc(MaxIO,sizeof(BLOCK))) == NULL) {
		fprintf(stderr,"could not allocate %d blocks\n",MaxIO);
	}
	for (i=0; i < MaxIO; i++)  {
		cache_list[i].b_next_off = (int) (cache_list+i+1);
		cache_list[i].b_ptr = data_area+i*512;
	}
	cache_list[i-1].b_next_off = 0;
	cache_list[0].b_block = 1;
	pid = getpid();
	if ((ProxyPid = qnx_proxy_attach(pid,NULL,0,0)) == -1) {
		perror("proxy:");
		return -1;
	}
	(*drvinit)(ProxyPid);
	for (i=0; i < num_devs; i++)
		(*drvopen)(i,1);
	while (1) {
	int	drive;
	long cur_blk, nblocks;
	long	ttime;	/* nnoo sseee */
	int	c;
	double	throughput;
		drive = get_long("enter drive id:");
		cur_blk = get_long("enter first block:");
		nblocks = get_long("enter number of blocks:");

		printf("testing drive %d, range %ld - %ld \n",
			drive, cur_blk, cur_blk+nblocks);
		
		if ((c= make_sure("Is this correct {Y,N,Q}?")) == 0)
			continue;
		if (c == -1)
			break;
		ttime =test_disk(drive,cur_blk,cur_blk+nblocks);
		printf("time=%ld.%ld\n",ttime/10000,ttime%10000);
		throughput = (nblocks*512)/ttime;
		printf("throughput = %f bytes/s\n",throughput*10000);
	}
	(*drvexit)();
  	return(0);
}

long test_disk(int drive, long cur_blk, long max_blocks)
{
int		i;
int	s1[4];
int	__far *tickkit = (void __far *)MK_FP(0xb0,0x2);
struct	_mxfer_entry write_tab[8];
pid_t	pid;
int		offset;
long	result;

/* mark time here */
	s1[0] = *tickkit;
	s1[1] = tickkit[1];
	cur_blk = 1;
	while (cur_blk < max_blocks) {
		if ((pid=Receive(0,data_area, 512 * MaxIO)) == ClientPid) {
/* Ok, son is ready, issue an IO */
			offset = 0;
			cache_list[0].b_block = cur_blk;
			(*drvrio)(drive,0,MaxIO,cache_list);
		} else if (pid == ProxyPid) {
			if (device_tab[0].d_nblks == 0) {
				cur_blk++;
				Reply(ClientPid,0,0);
			} else {
				for (i=0; i < device_tab[0].d_nblks; i++) {
					_setmx(write_tab+(i&07), cache_list[i].b_ptr,512);
					if (((i+1)&07) == 0) {
						Writemsgmx(ClientPid, offset, 8, write_tab);
						offset += 8*512;
					}
				}
				cur_blk += i;
				if ((i&07) != 0) {
					Replymx(ClientPid, (i-1)&07, write_tab);
				} else {
					Reply(ClientPid, NULL, 0);
				}
			}
		} else {
			fprintf(stderr,"unknown pid %d\n",pid);
		}
	}

	s1[2] = *tickkit;
	s1[3] = tickkit[1];
	result = ((long)s1[3]*10000 + (long)s1[2]) - ((long)s1[1]*10000 + (long)s1[1]);
	return result;
}

long get_long(char *prompt)
{
char	buffer[32];
long	t;
	fflush(stdin);		/*	does this really clear it? */
	fwrite(prompt,strlen(prompt),1,stdout);
	fgets(buffer,31,stdin);
	t = strtol(buffer,NULL,0);
	return t;
}

int	make_sure(char *prompt)
{
char	buffer[32];
int		i;
	while (1) {
		fflush(stdin);
		fwrite(prompt,strlen(prompt),1,stdout);
		if (fgets(buffer,31,stdin) == NULL)
			return -1;
		for (i=0; isspace(buffer[i]); i++);
		if (buffer[i] == '\0')
			continue;
		if (toupper(buffer[i]) == 'Y')
			return 1;
		if (toupper(buffer[i]) == 'N')
			return 0;
		if (toupper(buffer[i]) == 'Q')
			return -1;
	} 
}
		
