#include <stdlib.h>
#include "pragma.h"

/*
	trace:	some utilities to aid tracing.

	void trace_init(void __far *tracebuf, int trace_size);

	int	trace_enable();

	int	trace_disable();

	void __far *trace_head();

	void __far *alloc_trace(int nbytes).

	usage:
		You must call trace init first.  This is to provide it with a place
		to store the trace records.  
		alloc_trace() will allocate nbytes for a trace record.  Note that the
		trace record will be contiguous, thus a single record cannot wrap the
		end of the buffer.
		trace_disable will allow alloc_trace() calls to succeed, but the data
		stored will not be remembered.
*/


static	char	__far *tr_bufp;
static	int		tr_size;
static	int		tr_ok;
static	int		tr_offset;


void trace_init(void __far *bufp, int nbytes)
{
	tr_bufp = bufp;
	tr_size   = nbytes;
	tr_ok     = 0;
	return ;
}

trace_enable()
{
	tr_ok = 1;
}

trace_disabe()
{
	tr_ok = 0;
}

void __far *trace_alloc(int nbytes)
{
char __far *p;
int	psw;	
	
	if (!tr_ok) {
		return tr_bufp + tr_offset;
	}

	p = tr_bufp;
	psw = disable();

		if (nbytes + tr_offset > tr_size)
			tr_offset = 0;

		p += tr_offset;
		if (tr_ok && (tr_offset + nbytes < tr_size)) {
			tr_offset += nbytes;
		}

	restore(psw);

	return p;
}	

/*
	next location to be alloced
*/
void __far *trace_head()
{
	return tr_bufp + tr_offset;
}
