

#include	<stdio.h>
#include	<stdlib.h>
#include	<unistd.h>
#include	<string.h>

#include	<sys/kernel.h>
#include	<sys/irqinfo.h>

#include	<diskio.h>

#include	"endian.h"
#include	"genscsi.h"
#include	"aha1540.h"
#include	"ahaextrn.h"


#define	LOCAL	


uchar	ahabuf[18];

int	aha_loaded = 0;
volatile aha_hacc = 0;


pid_t __far	int_handler()
{
pid_t	sigpid = 0;
SCSI	*disk;	
int	istat;
disp_str("!!");
	while ((istat = io_in(ioport.int_status)) & AINT) {
		io_out(ioport.control,IRST);
disp_str("stat=");
disp_hex(istat);
		if (istat & SCRD) {
			ll_debug();
			continue;
		}
		if (istat & HACC) {
			disp_hex(io_in(ioport.status));
			aha_hacc = 1;
			continue;
		}
		if (istat & MBOA) {		
			ll_debug();		/* never happen! */
			continue;
		}

		if (istat & MBIF) {
disp_str("**");
			while (mboxes[inbox_base+last_ibox][0] != MBI_FREE) {
				switch (mboxes[inbox_base+last_ibox][0]) {
	            case	MBI_FREE:
					ll_debug();
					/* we are done. */
					break;
				case	MBI_COMPLETE:
				case	MBI_ERROR:
					disp_str("mbi complete");
					disk = &devtab[mowns[last_ibox]];
					sigpid = (*(disk->event_hdlr))(disk, Interrupt);
					mboxes[inbox_base+last_ibox][0] = MBI_FREE;
					break;
				case	MBI_ABORT:
				case	MBI_ABORTLOST:
				case	MBI_TARGET:
					ll_debug();
					break;
				default:
					ll_debug();
					break;
				}
				if (++last_ibox >= num_boxes)
					last_ibox = 0;
			}
			continue;
		}
			
	}
	return sigpid;
}



/*
	This module contains routines to initial the data structures 
	used in the scsi driver.

*/

LOCAL	unsigned	aha_addresses[] = {
				0x130, 0x134, 0x230, 0x234, 0x330, 0x334, 0
			};

LOCAL	unsigned	dma_table[8][4] = {
			{	0x0b, 0x0c, 0x0a, 0 	},
			{	0,    0,    0,    0 	},
			{	0,    0,    0,    0 	},
			{	0,    0,    0,    0		},
			{	0,    0,    0,    0 	},
			{	0xd6, 0xc1, 0xd4, 0x01	},
			{	0xd6, 0xc2, 0xd4, 0x02	},
			{	0xd6, 0xc3, 0xd4, 0x03	}
		};

LOCAL	find_adaptec()
{
int	stat;
int	i;
int	port;
	if (base_address == 0) {
		for (i=0; port = aha_addresses[i]; i++) {
			stat = io_in(port+STATUS);
			if (stat==STST || stat==DIAGF || stat==IDLE || stat==(IDLE|INIT))
				break;
		}
		if (port == 0)  {
disp_str("couldn't find port");
			return -1;
		}
	} else {
		stat = io_in(port+STATUS);
    }
	if (stat==STST) {	/*	Self test in progress */
		delay(2000);	/*	2000 millisecond sleep */
		stat = io_in(port+STATUS);
	}
	if (stat == DIAGF) { /*	Failed diagnostics */
disp_str("diagnostic failed");
		return -1;
	}
	if (stat!=IDLE && stat!=(IDLE|INIT)) {
disp_str("wrong stat "); disp_hex(stat);
		return -1;
	}

	base_address     = port;
	ioport.control   = base_address + 0;
	ioport.status    = base_address + 0;
	ioport.command   = base_address + 1;
	ioport.data      = base_address + 1;
	ioport.int_status= base_address + 2;
	return 0;
}


/*
	return position of least bit set 
*/
LOCAL	int	extract_bit(int value)
{
int	i;
	if (value == 0)
		return -1;		/*	no bits set */
	for (i=0; (value & (1 << i)) == 0; i++)
		;
	return i;
}



LOCAL	find_parms(unsigned *irq_level, unsigned *dma_ch, unsigned *scsi_id)
{

	/*	Is it an AHA-154xA ? */
	ahabuf[0] = 0;		/*	make sure! */
	if (aha_cmd(AHA_INQUIRE, ahabuf)) {
disp_str("inquire failed");
		return -1;
	}
	wait_reply(AHA_INQUIRE, ahabuf);
	if (ahabuf[0] != 'A') {
disp_str("ahabuf[0] != 'a'");
		return -1;
	}
	if (aha_cmd(AHA_CONFIG, ahabuf)) {
disp_str("config failed");
		return -1;
	}
	wait_reply(AHA_CONFIG,ahabuf);
	
	if ((*dma_ch = extract_bit(ahabuf[0])) == -1) {
disp_str("dma ch not found");
		return -1;
	}
	if ((*irq_level = extract_bit(ahabuf[1])) == -1) {
disp_str("irq not found");
		return -1;
	}
	*irq_level += 9;

	*scsi_id = ahabuf[2] & 0x07;
	return 0;
}


adaptec_init()
{
unsigned	scsi_id,int_id;
long p;

	if (find_adaptec() == -1) {
disp_str("find adaptec failed");
		return -1;
	}

	if (find_parms(&ctl_interrupt, &dma_channel, &scsi_id) == -1) {
disp_str("find parms failed!");
		return -1;
	}       
disp_str("parms: ");
disp_str("port =");	disp_hex(base_address);
disp_str("int  ="); disp_hex(ctl_interrupt);
disp_str("dma  ="); disp_hex(dma_channel);
disp_str("scsi ="); disp_hex(scsi_id);


/*
 * Install the interrupt handler here.
 */

	if ((int_id = qnx_hint_attach(ctl_interrupt, 
				MK_FP(my_cs(), int_handler), my_ds())) == -1) {
disp_str("hint attach failed!");
		return -1;
	}
	aha_loaded = 1;

	/*	bus mastering dma */
	io_out(dma_table[dma_channel][0], dma_table[dma_channel][1]);
	io_out(dma_table[dma_channel][2], dma_table[dma_channel][3]);

/*	do magic to install mailbox to scsi.
*/

	init_mboxes();

	p = phys_addr(MK_FP(my_ds(), mboxes));

	ahabuf[0] = num_boxes;
	swab_24(ahabuf+1,(uchar *)&p);

	if (aha_cmd(AHA_MBINIT, ahabuf)) {
disp_str("mbox init failed!");
		return -1;
	}
	wait_reply(AHA_MBINIT,ahabuf);

	if (bus_on_time != -1) {
		ahabuf[0] = bus_on_time;
		if (aha_cmd(AHA_BUSON_TIME, ahabuf)) {
disp_str("buson failed!\n");
			return -1;
		}
		wait_reply(AHA_BUSON_TIME, ahabuf);
	}
	if (bus_off_time != -1) {
		ahabuf[0] = bus_off_time;
		if (aha_cmd(AHA_BUSOFF_TIME, ahabuf)) {
disp_str("busoff failed!\n");
			return -1;
		}
		wait_reply(AHA_BUSOFF_TIME, ahabuf);
	}
	if (set_transfer_speed != -1) {
		ahabuf[0] = set_transfer_speed;
		if (aha_cmd(AHA_XFER_SPEED, ahabuf)) {
			return -1;
		}
		wait_reply(AHA_XFER_SPEED, ahabuf);
	}

	if (aha_cmd(AHA_DEVICES,ahabuf) == -1) {
disp_str("get devices failed");
		return -1;
	}
	wait_reply(AHA_DEVICES,devmap);

	return(0);
}




void init_mboxes()
{
int	i;
	for (i=0; i < MAX_MBOX; i++) {
		mowns[i] = -1;
	}
	memset(mboxes,sizeof(mboxes),0);
	mbox_next = 0;
}


alloc_mbox(int unitno)
{
int	i;
int	psw;
	psw = disable();
	i = mbox_next;
	if (mowns[i] != -1) {
/* crash and burn:  we ran out of mailboxes! */
		restore(psw);
		ll_debug();
		psw = disable();
	}
	if (++mbox_next >= num_boxes)
		mbox_next = 0;
	mowns[i] = unitno;
	restore(psw);
	return i;
}

void free_mbox(int mbox)
{
	mowns[mbox] = -1;
	mboxes[outbox_base + mbox][0] = MBI_FREE;
}

/*
	These tables incode the following info:
		aha_cmdlen		Number of bytes in the command.
		aha_replen		Number of bytes in the reply.
		aha_sync		Is command synchronous 
						( implies--> wait for idle, expect cmd complete
*/


static	int	aha_cmdlen[] = 		
		{    0,  4,  0, -1,  0,  1,  4,  1,  1,  1,  0,  0,  2, -2, -1, -1,
		    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  3,  3,  3,  3, -1,  1 
 		};
static	int	aha_replen[] =
		{    0,  0,  0, -1,  4,  0,  0,  0,  0,  0,  8,  3,  0, 16, -1, -1,
		    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  0,  0,  0,  0, -1,  1
		};

static	int	aha_sync[] = 
		{    1,  1,  0,  1,  1,  0,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
		     1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1
		};



/*
 *	Execute an AHA-154xA command
 */


aha_cmd(int cmd, uchar *cmd_buf)
{
register int i;
int cmd_cnt;
int	issync;
int	stat;

	if (cmd > sizeof(aha_cmdlen)/sizeof(int)) {
disp_str("bad cmd");
		return -1;
	}

	cmd_cnt = aha_cmdlen[cmd];
	issync = aha_sync[cmd];

	if (cmd_cnt == -1) {
disp_str("cmd length insane!");
		return -1;
	}

	if (cmd_cnt == -2)
		cmd_cnt = cmd_buf[0];

	/*	Most commands require an idle host adaptor.... */
	if (issync)
		while (!(io_in(ioport.status) & IDLE))
			;

	/*	Command port must be empty */
	while ((stat=io_in(ioport.status))& CDF)
		;
disp_str("aha_cmd_st0:");	disp_hex(stat);

disp_char('{');	disp_hex(cmd); disp_char('}');
	io_out(ioport.command, cmd);

	/*	Wait for command to be accepted */
	while ((stat=io_in(ioport.status)) & CDF)
		;

disp_str("aha_cmd_st1:");	disp_hex(stat);

	/* Check for invalid command */
	if ((stat=io_in(ioport.status)) & INVDCMD) {
		disp_str("INVALID COMMAND!");
		io_out(ioport.control,IRST);
		return -1;
	}

disp_str("aha_cmd_st2:");	disp_hex(stat);
disp_char('<');
	for (i=0; i < cmd_cnt; i++) {
		while (1) {
			stat = io_in(ioport.status);
			if (stat & INVDCMD) {
/* don't just sit there: do something! */
disp_str("invalid cmd!");
				io_out(ioport.control,IRST);
				return -1;
			}
			if ((stat & CDF) == 0)
				break;
		}
disp_hex(cmd_buf[i]);
		io_out(ioport.data,cmd_buf[i]);
	}
disp_char('>');
disp_str("aha_cmd_st3:");	disp_hex(stat);
	return 0;
}

wait_reply(int cmd, uchar *repbuf)
{
	
	if (aha_replen[cmd]) {
		aha_reply(aha_replen[cmd], repbuf);
		if (io_in(ioport.status) & INVDCMD) {
			io_out(ioport.control, IRST);
			return -1;
		}
	}
	if (! aha_loaded) {
		while ((io_in(ioport.int_status) & HACC) == 0) {
			delay(50);			/*	50 msecs guarantee */
		}
		io_out(ioport.control, IRST);
		return 0;
	}
	if (aha_sync[cmd]) {
		while (!aha_hacc)
			sleep(1);
		aha_hacc = 0;
	}
	return 0;
}


aha_reply(int nbytes, uchar *reply_buf)
{

disp_char('[');

	while (nbytes--) {
/*	Wait for the data port to fill */
		while ((io_in(ioport.status) & DF) == 0)
			;
		*reply_buf++ = io_in(ioport.data);
disp_hex(*(reply_buf-1));
	}
disp_char(']');
	return 0;
}

