

/*
	The data types 'be_32', 'be_24' and 'be_16' are for
	BIG ENDIAN 32 bit, 24 bit and 16 bit resp.
	The corresponding 'swabs' will assign with reversed byte ordering
	as appropriate.

 */

typedef unsigned char uchar;
typedef unsigned int  word;



typedef uchar be_16[2];
typedef	uchar be_24[3];
typedef	uchar be_32[4];

#define	swab_dword(x,y) ((x)[0] = (y)[3], (x)[1] = (y)[2], \
 						 (x)[2] = (y)[1], (x)[3] = (y)[0])

#define	swab_word(x,y) ((x)[0] = (y)[1],  (x)[1] = (y)[0])

#define	swab_24(x,y) ((x)[0] = (y)[2],(x)[1] = (y)[1], (x)[2] = (y)[0])

#define swap4to4(x, y)	swab_32(x,y)
#define swap3to3(x, y)	swab_24(x,y)
#define swap2to2(x, y)	swab_16(x,y)


