/*
	Qnx 4.0 SCSI Driver.

	This modules generates scsi messages for common high-level functions,
	including:
		read
		write
		...

	It should be independant of the underlying scsi driver.  This one
	is being tested for the adaptec 1540xxxx.


	Note all scsi multi-byte data types are defined as 'big-endian'.
	intel architecture is little-endian --> thus all the "swab_datatype".

*/



#include	<stdio.h>
#include	<stdlib.h>
#include	<unistd.h>
#include	<string.h>


#include	<diskio.h>

#include	"endian.h"
#include	"genscsi.h"
#include	"aha1540.h"
#include	"ahaextrn.h"

#if 0
scsi_read(int unitno, uchar *bufp, long blockno, unsigned nblocks)
{
uchar	*cmd = bufp;

	*cmd++ = SCSI_OP(1,SC_READ);
	*cmd++ = unitno << 5;
	swab_dword(cmd, (uchar *) & blockno);
	cmd += sizeof(be_32);
	*cmd++ = 0;
	*cmd++ = 0;
	*cmd++ = 0;
	swab_word(cmd, (uchar *) & nblocks);
	cmd += sizeof(be_16);
	*cmd++ = 0;
	return cmd - bufp;
}

scsi_write(int unitno, uchar *bufp, long blockno, unsigned nblocks)
{
uchar	*cmd = bufp;

	*cmd++ = SCSI_OP(1,SC_WRITE);
	*cmd++ = unitno << 5;
	swab_dword(cmd, (uchar *) & blockno);
	cmd += sizeof(be_32);
	*cmd++ = 0;
	*cmd++ = 0;
	*cmd++ = 0;
	swab_word(cmd, (uchar *) & nblocks);
	cmd += sizeof(be_16);
	*cmd++ = 0;
	return cmd - bufp;
}
#endif

scsi_read(int unitno, uchar *bufp, long blockno, unsigned nblocks)
{
uchar	*cmd = bufp;

	*cmd++ = SCSI_OP(0,SC_READ);
	swab_24(cmd, (uchar *) & blockno);
	*cmd &= 0x1f;		/*	trim to 21 bit address */
	*cmd |= unitno << 5;
	cmd += sizeof(be_24);
	*cmd++ = nblocks;
	*cmd++ = 0;
	return cmd - bufp; 
}

scsi_write(int unitno, uchar *bufp, long blockno, unsigned nblocks)
{
uchar	*cmd = bufp;

	*cmd++ = SCSI_OP(0,SC_WRITE);
	swab_24(cmd, (uchar *) & blockno);
	*cmd &= 0x1f;		/*	trim to 21 bit address */
	*cmd |= unitno << 5;
	cmd += sizeof(be_24);
	*cmd++ = nblocks;
	*cmd++ = 0;
	return cmd - bufp; 
}

/*
 *	Inquiry
 */
scsi_inquiry(int unitno, uchar *bufp) 
{
uchar	*cmd = bufp;
	*cmd++ = SC_INQUIRY;
	*cmd++ = unitno << 5;
	*cmd++ = 0;
	*cmd++ = 0;
	*cmd++ = 96;
	*cmd++ = 0;
	return cmd - bufp;
}

/*
 *	Start/Stop
 */
scsi_spindle(int unitno, uchar *bufp, int start)
{
uchar	*cmd = bufp;
	*cmd++ = SC_SPINDLE;
    *cmd++ = unitno << 5;
	*cmd++ = 0;
	*cmd++ = 0;
	*cmd++ = start != 0;
	*cmd++ = 0;
	return cmd - bufp;
}


/*
 *	Read Capacity or Read Partial Capacity
 */
scsi_capacity(int unitno, uchar *bufp)
{
uchar	*cmd = bufp;
	
	*cmd++ = SC1_RD_CAP;
	*cmd++ = unitno << 5;
	memset(cmd,0,8*sizeof(uchar));
	cmd += 8;
	return cmd - bufp;
}

scsi_test_rdy(int unitno, uchar *bufp)
{
uchar	*cmd = bufp;
	*cmd++ = SC_UNIT_RDY;
	*cmd++ = unitno << 5;
	*cmd++ = 0;
	*cmd++ = 0;
	*cmd++ = 0;
	*cmd++ = 0;
	return cmd - bufp;
}


