

/*-- PS/2 ESDI Hard Disk I/O assignments --*/
#define INTERFACE_CMD		0	/* Write 16		*/
#define INTERFACE_STATUS	0	/* Read  16		*/
#define	CONTROL				2	/* Write  8		*/
#define	STATUS				2	/* Read   8		*/
#define	INT_STATUS			3	/* Read   8		*/
#define	ATTENTION			3	/* Write  8		*/

/*
	put this in & use it to address the esdi card.
*/
struct	esdi_ioblk {
	unsigned	iface_cmd;		/*	write 16 */
	unsigned	iface_stat;		/*	read 16 */
	unsigned	cntrl;			/*	write 8 */
	unsigned	status;			/*	read 8 */
	unsigned	int_stat;		/*	read 8 */
	unsigned	attention;		/*	write 8 */
};


/*-- Commands for Attention Register --*/
#define	COMMAND_REQUEST	0x01	/* Indicate upcoming command				*/
#define	END_OF_INT		0x02	/* End of interrupt							*/
#define	ABORT_COMMAND	0x03	/* Abort current command					*/
#define	ADAPTOR_RESET	0x04	/* Reset adaptor							*/

/*-- Control register bits --*/
#define DMA_ENABLE		0x02	/* Enable DMA operations					*/
#define INT_ENABLE		0x01	/* Enable INT's to the bus					*/

/*-- Status bits found in status register --*/
#define BUSY			0x10
#define STATUS_OUT		0x08
#define CMD_REG_FULL	0x04
#define XFER_REQUEST	0x02
#define	INT_REQUEST		0x01

/*-- Controller Command Codes --*/
#define READ_DATA		0x4601	/* Read sector								*/
#define	WRITE_DATA		0x4602	/* Write sector								*/
#define READ_VERIFY		0x4603	/* Read verify (to test without DMA)		*/
#define GET_DEV_CONFIG	0x0609	/* Get device configuration					*/

/*-- IO port and bit for flashing the hard disk light --*/
#define SYS_PORT_A	0x0092
#define DISK_LIGHT	0x40


#define READ_BLK	0	/* ??????????? */
#define WRITE_BLK	1	/* ??????????? */
#define	GET_STATUS	2	/* ??????????? */

#define MAX_NDRIVES		2		/* 2 physical drives				*/
#define DISK_TYPE		1		/* 0-floppy, 1-fixed, 2-ramdisk, ...*/
#define DMA_CHANNEL		5

#define	MAX_IO			34		/* Largest single request I/O amount		*/
#define MAX_PARALLEL	1		/* Maximum pending operations				*/
#define	STACK_SIZE		256		/* Size of locally allocated stack			*/
#define CTL_ADDRESS		0x3510	/* Control address for disk controller		*/
#define CTL_INTERRUPT	14		/* Interrupt line for disk controller		*/

/*		Interrupt Codes returned! */

#define	EI_CC_OK		1
#define	EI_CC_ECC	 	3
#define	EI_CC_RETRY		5
#define	EI_FORM_PART	6
#define	EI_CC_RE_ECC	7
#define	EI_CC_WARN		8
#define	EI_ABORT_OK		9
#define	EI_RESET_OK		10
#define	EI_DTR			11
#define	EI_CC_FAILED	12
#define	EI_DMA_FAIL		13
#define	EI_CMD_ERR		14
#define	EI_ATTN_ERR		15

