

#define	MAX_IO			34		/* Largest single request I/O amount		*/
#define	MAX_DRIVES		2		/* Two drives max on a WD controller		*/
#define MAX_PARALLEL	1		/* Maximum pending operations				*/
#define	STACK_SIZE		64		/* Size of locally allocated stack			*/
#define CTL_INTERRUPT	14		/* Interrupt line for disk controller		*/

#define	PRIMARY_ADDR		0x1f0
#define	SECONDARY_ADDR		0x170

#define	FDC_PRIMARY		0x3f6
#define	FDC_SECONDARY		0x376

/*
 *  Define driver entry codes
 */
#define INIT_DRIVE		0
#define RW_BLK			1
#define FORMAT			2
#define GET_STATUS		0x80

/*
 *  Define modes
 */
#define READ_BLK		0
#define WRITE_BLK		1

#define MAX_DISK		2		/*	Maximum number of physical disks per controller */
#define MAX_LOGICAL		4		/*	Maximum number of logical disks per disk */
#define MAX_DRIVE		8		/*	Maximum number of drives */

#define BASE_SEL	0x38		/* ??? Bad name for this... */
#define BASE_SEG	0x00

/*
 *	Disk flags
 */
#define F_INITIALIZED	0x01;


/*
 *	WD Hard Disk I/O assignments
 */
#define DATA			0
#define ERR_REG			1
#define PRECOMP			1
#define SCTR_COUNT		2
#define SECTOR			3
#define CYL_LOW			4
#define CYL_HIGH		5
#define DRV_HEAD		6
#define STATUS			7
#define COMMAND			7

/*
 *	Controller Commands
 */
/* flags */
#define	DISABLE_RETRY	001
#define	BDRQ_INT		010
#define	MULTI_SECT		004

#define RESTORE			0x10	/* Restore with fast steps */
#define SEEK			0x70	/* Seek with fast steps */
#define READ_SECTOR		(0x20)
#define	WRITE_SECTOR	(0x30)
#define SET_PARMS		0x91	/* Tell controller #heads and #sectors/track */

/*
 *	Status bits
 */ 
#define BUSY			0x80
#define READY			0x40
#define WRITE_FAULT		0x20
#define SEEK_COMPLETE	0x10
#define DRQ				0x08
#define ECC_CORR		0x04
#define CIP				0x02
#define ERROR			0x01


#define	EMASK			0x50
#pragma off (check_stack);

