/*
** QNX 4.xx - qic02 driver type definitions
*/
#ifndef		__FSYS_H_INCLUDED
#include	<sys/fsys.h>
#endif

#ifndef		__SYS_MSG_H_INCLUDED
#include	<sys/sys_msg.h>
#endif


#pragma pack( 1 );

typedef struct
{	char	msg[ MAX_PMSG_LEN ];
/*****************************************************************/
}	QIC02_PMSG_STRUCT;
/*****************************************************************/

typedef enum
{
#	include	"qic02err.h"
/*****************************************************************/
}	ERROR_CODE;
/*****************************************************************/

typedef struct
{	unsigned short				 lsel;
	long						 nbytes;
	unsigned long				 phys_addr;
/*****************************************************************/
}	TAPE_CACHE_2_PHYS_STRUCT;
/*****************************************************************/

typedef struct
{	unsigned short				 status;
	unsigned short				 control;
	unsigned short				 command;
	unsigned short				 data;
	unsigned short				 dma;
/*****************************************************************/
}	TAPE_PORT_STRUCT;
/*****************************************************************/
	
typedef struct
{	unsigned short				 ready[ 2 ];		// Mask,Value pair
	unsigned short				 exception[ 2 ];	// Mask,Value pair
/*****************************************************************/
}	TAPE_STATUS_BIT_STRUCT;
/*****************************************************************/

typedef struct
{	unsigned short				 clear;		// Write this value to clear,
	unsigned short				 online;		// to enable
	unsigned short				 reset;		// to reset
	unsigned short				 request;	// to request reading of command
	unsigned short				 dma[ 3 ];	// to enable DMA 1,2 & 3
	unsigned short				 inton[ 3 ];	// to enable interrupt
/*****************************************************************/
}	TAPE_CONTROL_BIT_STRUCT;
/*****************************************************************/

typedef struct
{	char						 tname[ _DRIVER_NAME_LEN + 1 ];
	TAPE_PORT_STRUCT			 tps;
	TAPE_STATUS_BIT_STRUCT		 tsbs;
	TAPE_CONTROL_BIT_STRUCT		 tcbs;
/*****************************************************************/
}	TAPE_UNIT_STRUCT;
/*****************************************************************/

typedef struct
{	long						 block_no;
	unsigned short				 no_of_blocks;
	struct dma_buffer			 buffer;
/*****************************************************************/
}	TAPE_DMA_BUFFER_STRUCT;
/*****************************************************************/

typedef struct tcqs
{	struct tcqs					*np;
	struct _disk				*tip;

	struct
	{	unsigned				 common_command	: 1;
		unsigned				 read			: 1;
		unsigned				 write			: 1;
		unsigned								: 5;

	}	flag;

	union
	{	unsigned short			 command;
		TAPE_DMA_BUFFER_STRUCT	 dma;

	}	data;
/*****************************************************************/
}	TAPE_CMD_Q_STRUCT;
/*****************************************************************/

#pragma pack( 0 );


/* End of File */
